/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.army.hierarchy;

import fb.army.entities.Entity;
import fb.army.entities.Leader;

/**
 * the warchief's command
 * 
 * @author farfpeuf
 * 
 */
public class WarchiefCommand extends Command {

	/**
	 * returns command as a string to save it to a file
	 * 
	 * @return command as a string
	 */
	public String saveString() {
		String savestring = "w" + '\t' + name + '\t' + order + '\t'
				+ (changedOrders ? 'y' : 'n') + '\n';
		for (int i = 0; i < allEntities.size(); i++) {
			savestring += (((Entity) allEntities.get(i)).saveString() + '\n');
		} // for
		return savestring;
	}

	/**
	 * @param leader
	 *            The leader to set.
	 */
	public void setLeader(Leader leader) {
		super.setLeader(leader);
		army.setWarchief(leader);
	}

}
