/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.battlefieldelements;

import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;

import fb.army.entities.Entity;
import fb.util.FBColors;

/**
 * a sign with an associated value painted inside
 * 
 * @author farfpeuf
 * 
 */
public class SignWithValue extends Sign {

	// the value to paint
	private int value = 0;

	/**
	 * constructor
	 * @param e the entity to which this sign is attached
	 * @param value the initial value
	 */
	public SignWithValue(Entity e, int value) {
		super(e);
		this.value = value;
	}

	/**
	 * paint the sign on the battlefield
	 */
	public void paintImage(Graphics g, int dx, int dy, int scale) {
		super.paintImage(g, dx, dy, scale);
		g.setColor(FBColors.background);

		Font signfont, oldfont;
		oldfont = g.getFont();
		signfont = new Font("Times New Roman", Font.ITALIC, scale * 3);
		g.setFont(signfont);

		java.awt.font.FontRenderContext frc = ((Graphics2D) g)
				.getFontRenderContext();
		java.awt.geom.Rectangle2D r2d = g.getFont().getStringBounds(
				Integer.toString(value), frc);

		int sdx = (int) (-r2d.getWidth() / 2);
		int sdy = (int) (r2d.getHeight() / 2);

		g.drawString(Integer.toString(value), x * scale + dx + sdx, y * scale
				+ dy + sdy);
		g.setFont(oldfont);
	}

	/**
	 * change the sign value
	 * @param value the new value
	 */
	public void setvalue(int value) {
		this.value = value;
	}

}
