/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;

import fb.army.entities.Unit;
import fb.gui.frames.BattleFrame;
import fb.gui.widgets.ButtonValueChooser;
import fb.gui.widgets.FBButton;
import fb.util.Resources;

/**
 * panel for expand manoeuvre
 * 
 * @author farfpeuf
 * 
 */
public class ExpandPanel extends JPanel {
	/**
	 * current unit attempting expand manoeuvre
	 */
	private Unit unit;

	/**
	 * ok and cancel buttons
	 */
	private FBButton okButton, cancelButton;

	/**
	 * widget used to choose the number of warriors to add to the front line
	 */
	private ButtonValueChooser expandValueChooser;

	/**
	 * change unit attempting expand manoeuvre
	 * 
	 * @param u
	 *            the new unit
	 */
	public void setUnit(Unit u) {
		unit = u;
		int maxExpand = (unit.getLevel() + 1) * 2;
		int canExpend = unit.canExpend();
		int max = maxExpand;
		if (max > canExpend) {
			max = canExpend;
		}
		if (max > unit.maxExpend()) {
			max = unit.maxExpend();
		}
		expandValueChooser.setValues(1, max, max);
	}

	/**
	 * constructor build and assemble panel elements
	 */
	public ExpandPanel() {

		setLayout(new GridLayout(2, 1));
		okButton = new FBButton(Resources.getString("Expend"), null, true);
		okButton.setToolTipText(Resources.getString("expand.tt"));
		cancelButton = new FBButton(Resources.getString("Cancel"), null, true);
		expandValueChooser = new ButtonValueChooser();
		add(expandValueChooser);
		JPanel okCancelPanel = new JPanel();
		add(okCancelPanel);
		okCancelPanel.setLayout(new GridLayout(2, 1));
		okCancelPanel.add(okButton);
		okCancelPanel.add(cancelButton);
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				unit.expend(expandValueChooser.getValue());
				BattleFrame.getInstance().setMovementPanel(unit);
			}
		});
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				BattleFrame.getInstance().setMovementPanel(unit);
			}
		});
		setSize(60, 120);
		setOpaque(false);
		validate();
	}
}