/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;

import javax.swing.JPanel;

import fb.gui.widgets.ButtonListener;
import fb.gui.widgets.FBButton;
import fb.phases.PlayerOrderPhase;
import fb.sound.SoundPlayer;
import fb.util.Resources;

/**
 * panel to choose a new order
 * 
 * @author coheris
 * 
 */
public class OrderPanel extends JPanel {
	/**
	 * the new order phase
	 */
	private PlayerOrderPhase orderPhase;

	/**
	 * set the new order phase
	 * 
	 * @param nop
	 *            the new order phase
	 */
	public void setPhase(PlayerOrderPhase nop) {
		this.orderPhase = nop;
	}

	/**
	 * constructor build and assemble panel elements
	 */
	public OrderPanel() {

		setLayout(new GridLayout(1, 3, 5, 5));
		FBButton attack = new FBButton(Resources.getString("attack"), "attack",
				true);
		FBButton oppose = new FBButton(Resources.getString("oppose"), "oppose",
				true);
		FBButton hold = new FBButton(Resources.getString("hold"), "hold", true);

		attack.setToolTipText(Resources.getString("charge.tt"));
		oppose.setToolTipText(Resources.getString("manoeuvre.tt"));
		hold.setToolTipText(Resources.getString("defend.tt"));

		add(attack);
		add(oppose);
		add(hold);

		setBounds(10, 10, 300, 100);
		setOpaque(false);
		validate();

		attack.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				SoundPlayer.getInstance().play("attack");
				orderPhase.setOrder('a');

			}
		});
		oppose.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				SoundPlayer.getInstance().play("oppose");
				orderPhase.setOrder('o');

			}
		});
		hold.addActionListener(new ButtonListener() {
			public void threadedActionPerformed() {
				SoundPlayer.getInstance().play("hold");
				orderPhase.setOrder('h');

			}
		});

	}

}
