/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.panels;

import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import fb.army.entities.SpellCaster;
import fb.gui.widgets.SlideValueChooser;
import fb.util.FBColors;
import fb.util.PercentageLayout;
import fb.util.Resources;
/**
 * additionnal panel to display spell caster recruitment options
 * 
 * @author farfpeuf
 * 
 */
public class SpellCasterRecruitPanel extends RecruitPanel{
	/**
	 * current spell caster
	 */
	private SpellCaster spellCaster;
	/**
	 * widget to chose initial number of magic points
	 */
	private SlideValueChooser magicPointsChooser;
	/**
	 * spell caster cost label
	 */
	private JLabel cost;

	/**
	 * constructor build and assemble panel elements
	 */
	public SpellCasterRecruitPanel(){
		JPanel cadrePanel = new JPanel();
		setBorder(BorderFactory.createLineBorder(FBColors.lightBorder));



		cadrePanel.setLayout(new PercentageLayout());
		magicPointsChooser=new SlideValueChooser(" "+Resources.getString("Magic")+" :");
		cost=new JLabel();
		cost.setHorizontalAlignment(0);
		cadrePanel.add(magicPointsChooser, new PercentageLayout.Constraint(10, 0, 80, 66));
		cadrePanel.add(cost, new PercentageLayout.Constraint(0, 66, 100, 34));

		setLayout(new GridLayout(1, 1));
		add(cadrePanel);

		validate();

            magicPointsChooser.addChangeListener(new ChangeListener() {
    			public void stateChanged(ChangeEvent e) {
					spellCaster.setMagicPoints(((JSlider)e.getSource()).getValue());
					spellCaster.setInitialMagicPoints(spellCaster.getMagicPoints());
					fireEntityChanged();
					cost.setText(" "+Resources.getString("Cost")+" : "+spellCaster.getCost());
                  }
		});
            magicPointsChooser.setToolTipText(Resources.getString("magic.tt"));
    }
	/**
	 * change Spell Caster
	 * 
	 * @param spellCaster
	 *            the new Spell Caster
	 */
	public void setSpellCaster(SpellCaster spellCaster){
		this.spellCaster=spellCaster;
		magicPointsChooser.setValues(0,99,spellCaster.getInitialMagicPoints());
	}

}
