/*
 * Copyright 2002 Farfpeuf/ AdetSoft. All rights reserved.
 * Use is subject to license terms.
 */
package fb.gui.widgets;

import java.awt.Component;
import java.awt.DisplayMode;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.SwingConstants;

/**
 * renderer to display a display mode in the options panel
 * 
 * @author farfpeuf
 * 
 */
public class DisplayModeCell extends JLabel implements ListCellRenderer {

	/**
	 * ListCellRenderer implementation
	 */
	public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {

		DisplayMode mode = (DisplayMode) value;

		StringBuffer text = new StringBuffer();
		text.append(mode.getWidth());
		text.append('*');
		text.append(mode.getHeight());
		text.append(' ');
		text.append(mode.getBitDepth());
		text.append(" bits ");
		text.append(mode.getRefreshRate());
		text.append(" hertz");
		setText(text.toString());
		return this;
	}

	/**
	 * constructor
	 */
	public DisplayModeCell() {
		super();
		setHorizontalAlignment(SwingConstants.CENTER);
	}

}
